unit DBFgen1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, XBase1, ComCtrls, ExtCtrls;

type
  STRUCT1 = record
       XNUM : byte ;
       CTYP : char ;
       XSIZ : smallint ;
       XDEC : smallint
  end ;
  STRINGX11   = String[011] ;
  STRINGX255  = String[255] ;

type
  TF1 = class(TForm)
    XBase1: TXBase;
    BTN1_OPEN: TButton;
    BTN2_CLOSE: TButton;
    XPOSITION: TEdit ;
    LAB1: TLabel;
    LAB2: TLabel;
    LAB3: TLabel;
    LAB4: TLabel;
    LFIC: TLabel;
    LREC: TLabel;
    LAB5: TLabel;
    Edit1: TEdit;
    UpDown1: TUpDown;
    BTN4_NEW: TButton;
    BTN6_CRE: TButton;
    BTN7_CPY: TButton;
    BTN8_DBF: TButton;
    OPENDIALOG1: TOpenDialog;
    BTN3_GO: TButton;
    LAB6: TLabel;
    BTN5_DEL: TButton;
    LDEL: TLabel;
    BTN9_EXIT: TButton;
    Shape1: TShape;
    Shape2: TShape;
    Shape3: TShape;
    Shape4: TShape;
    BTN0_WRITE: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure BTN1_OPENClick(Sender: TObject);
    procedure BTN2_CLOSEClick(Sender: TObject);
    procedure BTN4_NEWClick(Sender: TObject);
    procedure BTN5_DELClick(Sender: TObject);
    procedure BTN6_CREClick(Sender: TObject);
    procedure BTN7_CPYClick(Sender: TObject);
    procedure BTN8_DBFClick(Sender: TObject);
    procedure XPOSITIONExit(Sender: TObject);
    procedure BTN9_EXITClick(Sender: TObject);
    procedure BTN3_GOClick(Sender: TObject);
    procedure BTN0_WRITEClick(Sender: TObject);
  private
    { Dclarations prives }
    VDBFMAJ     : boolean   ; // true si MISE A JOUR permise
    FIELD_AFF   : smallint  ; // nombre de champs affichs , 0 = aucun
    FIELD_DESC  : array[1..128] of STRUCT1 ;
    FIELD_TEXT  : array[1..128] of TStaticText ;
    FIELD_EDIT  : array[1..128] of TEdit  ;
    procedure INIT_CONTROLS(Sender: TComponent);
    procedure GET_NOM_FICHIER(CCAS : byte ) ;
    procedure VOIR_CONTROLES( VOPEN : boolean ) ;
  public
    { Dclarations publiques }
    procedure AFFICHER_RECORD ;
    procedure UPDATE_RECORD ;
    procedure NOUVEAU_RECORD ;
  end;

var
  F1: TF1;

implementation

{$R *.DFM}

uses DBFgen2 , DBFgen3 ;

const
   SPACE    = ' ' ;

//**********************************************************************
//**********************************************************************
//**********************************************************************

//=================================================================
function ZEROSTR( NX1 : smallint ; NC2 : smallint ) : STRINGX11 ;
var S1 : STRINGX11 ;
    J1 : smallint ;
begin
    str( NX1:10 , S1 ) ;
    for J1 := 1 to 10 do begin
         if S1[J1] = SPACE then  S1[J1] := '0' ;
    end ;
    if (NC2 >= 1 ) and (NC2 < 10 ) then
         S1 := copy(S1 , 11 - NC2 , NC2 ) ;
end ;

//=================================================================
function ZEROSTR3( NX1 : smallint ) : STRINGX11 ;
var S1 : STRINGX11 ;
    J1 : smallint ;
begin
    str( NX1:3 , S1 ) ;
    for J1 := 1 to 3 do begin
         if S1[J1] = SPACE then  S1[J1] := '0' ;
    end ;
    Result := S1 ;
end ;

//=================================================================
function ZEROSTR1D( NX1 : smallint ; CT2 : char ) : STRINGX11 ;
var S1 : STRINGX11 ;
begin
    str( NX1:3 , S1 ) ;
    if CT2 = 'N' then begin
         Result := ',' + S1[3]   ;
    end else begin
         Result := SPACE + SPACE ;
    end ;
end ;

//=================================================================
function ROUND10( NX1 : smallint ) : smallint ;
var
    J1 : smallint ;
begin
    J1 := NX1 mod 10 ;
    Result := NX1 + 10 - J1 ;
end ;

//========================================================
function FORMAT_NUM(ZSTR1 : STRINGX255 ; XSIZ2 , XDEC3 : smallint) : STRINGX255 ;
var Z1 : char ;
    Z2 , Z3 : STRINGX255 ;  // parties Entiere et decimale
    X1 , X2 , X3 , X4 : smallint ;
    C1 , C2 : char ;
    V2      : boolean ;
begin
    X2 := 0 ;  X3 := 0 ; V2 := false ;
    C2 := DecimalSeparator ; Z1 := SPACE ;
    for X1 := 1 to length(ZSTR1) do begin
        C1 := ZSTR1[X1] ;

        if C1 = '-' then begin
                    //.... le SIGNE ngatif est accept n'importe ou !
                    Z1 := C1 ;
        end else begin
            if C1 = C2 then begin
                    V2 := true ;  // Virgule Decimale trouve
            end else begin
                if (C1 >= '0') and (C1 <= '9') then begin
                     if V2 then begin
                           //.... CHIFFRES en partie dcimale
                         inc(X3) ; Z3[X3] := C1 ;
                     end else begin
                         //.... CHIFFRES en partie entiere
                         inc(X2) ; Z2[X2] := C1 ;
                     end ;
                end ;
            end ;
        end ;
    end ;
    SetLength(Z2 , X2) ;
    SetLength(Z3 , X3) ;
    //.... ajustement du nombre de dcimales ...
    if XDEC3 = 0 then begin
         SetLength(Z3 , 0) ;
         X4 := XSIZ2 ;
    end else begin
         Z3 := copy(Z3+StringOfChar('0',18) , 1 , XDEC3 ) ;
         X4 := XSIZ2 - XDEC3 - 1 ;
    end ;
    //.... ajustement de la partie entiere ...
    if Z1 = '-' then  dec(X4) ;  // X4 = taille de la partie entiere
    if X4 <  1  then X4 := 1 ;
    if X2 > X4  then begin
                     X2 := X4 ;
                     SetLength(Z2 , X4) ;
                end ;
    if X2 < X4  then begin
                     repeat
                          Z2 := '0' + Z2 ;
                          inc(X2) ;
                     until X2 >= X4 ;
                end ;
    if Z1 = '-' then
          Result := Z1 + Z2
    else  Result := Z2 ;
    if XDEC3 > 0 then
          Result := Result + C2 + Z3 ;
end ;

//========================================================
function FORMAT_LOG(ZSTR1 : STRINGX255 ) : STRINGX255 ;
var C1 : char ;
begin
    C1 := ZSTR1[1] ;
    if C1 = SPACE then begin
            trim(ZSTR1) ;
            C1 := ZSTR1[1] ;
    end ;
    if length(ZSTR1) = 0 then C1 := 'T'
                         else C1 := UpCase(C1) ;
    if (C1='F') or (C1='N') or (C1='0') then Result := 'F'
                                        else Result := 'T' ;
end ;

//**********************************************************************
//**********************************************************************
//**********************************************************************

//========================================================
procedure TF1.GET_NOM_FICHIER(CCAS : byte ) ;
var
  LISTE1  : TStringList ;
  W1 , W2 : STRINGX255  ;
  J1 , J2 : smallint    ;
  XREC : integer ;
  CDEL : char    ;
  VDEL : boolean ;
begin
  Application.CreateForm(TF3, F3);
  case CCAS of
      1 : W2 := 'Cration du fichier avec la structure ci-dessous ' ;
      2 : W2 := 'Cration avec copie de la Structure du fichier courant ' ;
      3 : W2 := 'Copie du fichier courant vers un fichier nouveau ' ;
      else W2 := '???' ;
  end ;
  F3.TITRE31.Caption := W2 ;
  F3.SGRI.Enabled    := ( CCAS = 1 ) ;  // Visible
  F3.SGRI.ColWidths[0] := 30 ;
  //..................
  LISTE1 := TStringList.Create ;
  LISTE1.Clear ;
  XBase1.DBFExtractStruct(LISTE1 , true) ;
  for J2 := 1 to LISTE1.Count  do begin
      W1 := LISTE1.Strings[J2 - 1]  ;
      F3.SGRI.Cells[1 , J2] := W1 ;
      F3.SGRI.Cells[0 , J2] := IntToStr(J2) ;
  end ;
  //..................
  J1 := F3.ShowModal ;  // ModalResult
  //..................
  W1 := F3.LFIC.Text ;
  if (J1 <> 1) or (length(W1)=0) then begin
        exit ;
  end ;
  W1   := XBASE1.StandardDBFName(W1) ;
  XREC := StrToIntDef(F3.QREC31.Text , 0)  ;
  W2   := F3.CDEL31.Text ;
  CDEL := UpCase( W2[1] ) ; VDEL := (CDEL <> 'N') ;
  //-------- Traitement en fonction du cas ---------------
  case CCAS of
     1 : begin   // ***** CREATION d'un Fichier avec STRUCTURE *******
         Showmessage('DBFCreate : Creation du fichier '#013 + W1 ) ;
         LISTE1.Clear ;
         J2 := F3.SGRI.RowCount ;
         for J1 := 1 to J2 do begin
             W2 := F3.SGRI.Cells[1 , J1] ;
             if  length(W2) > 0 then  W2 := trim(W2) ;
             if (length(W2) > 3) and (pos('=',W2) > 0) then begin
                 LISTE1.Add(W2) ;
             end ;
         end ;
         XBase1.DBFCreate(W1 , LISTE1 ) ;
         end ;
     2 : begin   // ***** COPY STRUCTURE du Fichier courant *******
         Showmessage('DBFCopyStruct : COPY STRUCT vers fichier '#013 + W1 ) ;
         XBase1.DBFCopyStruct(W1) ;
         end ;
     3 : begin
         Showmessage('DBFCopyFile (COPY TO) vers '#013 + W1 ) ;
         XBase1.DBFCopyFile(W1 , XREC , VDEL ) ;
         end ;
  end ;
  F3.Release  ; // ou .Free ????
end ;

//======================================================================
procedure TF1.INIT_CONTROLS(Sender: TComponent);
const
   KX_LEFT1  =  10 ;
   KX_WIDTH1 = 200 ;
   KX_LEFT2  = 220 ;
   KX_WIDTH2 = 300 ;
   KX_TOP0   = 100 ;
   KX_TOP1   =  40 ;
   KX_COLOR1 =  $FFFFA0  ;  //  BLEU pale clair
   KX_COLOR2 =  $90C0FF  ;  //  SAUMON clair ( ROSE saumon )
var
    J1 , J2 , XTOP1 , X1 : smallint ;
    W1 , W2 : string    ;
    ZFLDNOM : STRINGX11 ;
    ZFLDTYP : Char ;
    ZFLDSIZ , ZFLDDEC : smallint ;
begin
    XTOP1 := KX_TOP1 ;  // par dfaut
    J2 := XBASE1.FieldCount ; if J2 > 128 then J2 := 128 ;
    FIELD_AFF := J2 ;
    W1 := EDIT1.Text ;
    for J1 := 1 to J2 do begin
       ZFLDNOM  := XBASE1.GetFieldName(J1) ;
       ZFLDTYP  := XBASE1.GetFieldTypeChar(J1) ;
       ZFLDSIZ  := XBASE1.GetFieldSize(J1) ;
       ZFLDDEC  := XBASE1.GetFieldDecimals(J1) ;
       with FIELD_DESC[J1] do begin  // STRUCT1
            XNUM := lo(J1)  ;
            CTYP := ZFLDTYP ;
            XSIZ := ZFLDSIZ ;
            XDEC := ZFLDDEC ;
       end ;
       //========== NOM DU CHAMP ======================
       // FIELD_TEXT[J1].Free ;
       FIELD_TEXT[J1] := TStaticText.Create(Sender)  ; // ou (nil) ;
       with FIELD_TEXT[J1]  do begin
           Name     := 'LC' + ZEROSTR3(J1) ;
           W2 := copy(ZFLDNOM + '               ' , 1 , 11) +
                 ' *' + ZFLDTYP + ZEROSTR3(ZFLDSIZ) +
                 ZEROSTR1D(ZFLDDEC , ZFLDTYP ) ;
           Caption    := W2 ;
           Left       := KX_LEFT1  ;
           Top        := KX_TOP0 + (J1-1) * XTOP1 ;
           Width      := KX_WIDTH1 ;
           AutoSize   := false     ;
           Visible    := true      ;
           Color      := KX_COLOR1 ;
           Font.Size  := 12 ;
           Font.Pitch := fpFixed ;
           Font.Name  := 'Courier New' ;
           Font.Style := [fsBold]  ;
           W1 := W1 + SPACE + Owner.Name + Name + copy(Caption,1,11) ;
           //------ le propritaire qui possde et libre l'objet ---------
           // voir proprit en lecture seule : OWNER = F1
           // Sender.InsertComponent( FIELD_LABEL[J1] ) ;
           // <==  utiliser si on a fait un .Create(nil)
           //     ou que l'on veut changer de propritaire
           //------- la fenetre ou apparait le controle visuel ------------
           // attention : indispensable ,  ne pas confondre avec OWNER !
           Parent   := Sender as TWinControl ;
           //-------
       end ; // with
       //========== VALEUR DU CHAMP ======================
       // FIELD_EDIT[J1].Free ;
       FIELD_EDIT[J1] := TEdit.Create(Sender)  ; // ou (nil) ;
       with FIELD_EDIT[J1]  do begin
           Name     := 'VC' + ZEROSTR3(J1) ;
           Text       := Name + 'XXXXX'  ;
           Left       := KX_LEFT2  ;
           Top        := KX_TOP0 + (J1-1) * XTOP1 ;
           // il rentre environ 27 car sur 300 pixels de large avec Height = -16
           Width      := ROUND10(11 * ZFLDSIZ + 15)  ;  // KX_WIDTH2 ;
           X1         := BTN1_OPEN.Left - KX_LEFT2 - 10 ;
           if Width > X1 then
              Width := X1 ;
           AutoSize   := false     ;
           Color      := KX_COLOR2 ;
           Font.Size  := 12        ;
           Font.Pitch := fpFixed   ;
           ReadOnly   := not VDBFMAJ   ;  // IMPORTANT !
           Visible    := true      ;
           if J1 = 1 then
                   XTOP1 := ROUND10( Height + 5 ) ;
           Height     := XTOP1 - 5 ;
           //-------
           Parent   := Sender as TWinControl ;
       end ; // with
    end ;
    EDIT1.Text := W1 ;
end ;

//========================================================
procedure TF1.AFFICHER_RECORD ;
var Z1 : STRINGX255 ;
    J1 : smallint ;
    V1 : boolean  ;
begin
    with XBASE1 do begin
        for J1 := 1 to FIELD_AFF do begin
           Z1 := Xbase1.GetFieldByNumber(J1) ;
           FIELD_EDIT[J1].Text := Z1 ;
        end ;
        LREC.Caption   := IntToStr(RecNo) + ' / ' + IntToStr(RecordCount) ;
        XPOSITION.Text := IntToStr(RecNo) ;
        V1 :=  Deleted ;
        if V1 then
              LDEL.Caption := 'Deleted'
        else  LDEL.Caption := 'Actif'  ;
    end ;
end ;

//========================================================
procedure TF1.UPDATE_RECORD ;
var Z1 , Z2 : STRINGX255 ;
    J1 : smallint ;
    ZDESC : STRUCT1 ;  // descriptif d'un champ
begin
   if not VDBFMAJ then begin
       exit ;
   end ;
   for J1 := 1 to FIELD_AFF do begin
        Z1 := FIELD_EDIT[J1].Text ;
        Z2 := FIELD_TEXT[J1].Caption ;
        //...... Formattage indispensable ..........
        ZDESC := FIELD_DESC[J1] ;
        with ZDESC do begin  // STRUCT1
             case CTYP of
                  'N' : Z1 := FORMAT_NUM(Z1 , XSIZ , XDEC ) ;
                  'L' : Z1 := FORMAT_LOG(Z1) ;
                  // rien a faire pour 'C' et 'D' ;  voir pour MEMO
             end ;
        end ;
        //......
        XBASE1.PutFieldByNumber( J1 , Z1 ) ;
   end ;
   XBASE1.PostChanges ;  // non indispensable si AutoUpdate = true
end ;

//========================================================
procedure TF1.NOUVEAU_RECORD ;
var X1 : cardinal ;
begin
  with XBase1 do begin
     X1 := RecordCount + 1 ;
     AppendBlank ;
     PostChanges ; // et  GotoEOF  sont inclus
     if X1 <> RecNo then begin
          ShowMessage('BIZARRE sur APPENDBLANK ') ;
          GotoRecord(X1) ;
     end ;
     AFFICHER_RECORD ;
  end ;
end ;

//========================================================
procedure TF1.VOIR_CONTROLES( VOPEN : boolean ) ;
var VVOI1 , VVOI2 : boolean ;
begin
   VVOI1 := ( VOPEN and XBASE1.Active ) ;  // fichier DBF O.K. ouvert
   VVOI2 := ( VVOI1 and (XBASE1.RecordCount >= 1))  ;

   BTN0_WRITE.Visible := (VVOI1 and VDBFMAJ) ; 

   BTN1_OPEN.Visible  := not VVOI1 ;
   BTN2_CLOSE.Visible := VVOI1 ;
   BTN4_NEW.Visible   := VVOI1 ;
   BTN7_CPY.Visible   := VVOI1 ;
   BTN8_DBF.Visible   := VVOI1 ;

   UpDown1.Visible    := VVOI2 ;
   LAB6.Visible       := VVOI2 ;
   BTN3_GO.Visible    := VVOI2 ;
   XPOSITION.Visible  := VVOI2 ;
   BTN5_DEL.Visible   := VVOI2 ;
end ;

//========================================================
procedure TF1.FormCreate(Sender: TObject);
begin
    FIELD_AFF := 0 ;
    VOIR_CONTROLES( false ) ;
end;

//======================================================================
procedure TF1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   if FIELD_AFF > 0 then
       BTN2_CLOSEClick(Sender);
end;

//======================================================================
procedure TF1.BTN0_WRITEClick(Sender: TObject);
begin
   if VDBFMAJ then
        XBASE1.PostChanges ;
end;

//======================================================================
procedure TF1.BTN1_OPENClick(Sender: TObject);
var VF1 : boolean  ;
    XM1 : smallint ;
begin
   VF1 := OPENDIALOG1.Execute ;
   if VF1 then begin
      //... ouverture du fichier ...
      XBase1.FileName := OPENDIALOG1.FileName ;
      XBase1.AutoUpDate := true ;
      XBase1.DebugErr := false  ;
      XBase1.Active   := true   ;
      //... si l'ouverture du DBF est O.K. ....
      if XBase1.Active then begin
           //......... CHOIX LECTURE SEULE ........
           XM1 := MessageDlg('Ouvrir le fichier en LECTURE SEULE ?'#013 +
                             'cela vite des modifications involontaires !' ,
                             mtConfirmation , [mbYES , mbNO ] , 0 ) ;
           VDBFMAJ := (XM1 = mrNO) ; // True si rponse NON = 7  ( OUI = 6 )
           if VDBFMAJ then LAB6.Caption := 'Read/Write'
                      else LAB6.Caption := 'Read-Only ' ;
           BTN4_NEW.Visible := VDBFMAJ ;
           //.........
           Xbase1.GotoBOF  ;
           LFIC.Caption    := OPENDIALOG1.FileName ;
           INIT_CONTROLS(Self) ;
           AFFICHER_RECORD ;
      end else begin
           LFIC.Caption    := 'Fichier DBF3 INVALIDE :' + OPENDIALOG1.FileName ;
           VF1 := false ;
      end ;
   end else begin  // VF1 est False
      LFIC.Caption    := 'AUCUN Fichier slectionn !' ;
   end ;
   VOIR_CONTROLES( VF1 ) ;
end;

//======================================================================
procedure TF1.BTN2_CLOSEClick(Sender: TObject);
var
    J1 : smallint ;
begin
    //... fermeture du fichier ...
    XBase1.Active      := false ;
    for J1 := 1 to FIELD_AFF do begin
        FIELD_TEXT[J1].Free ;
        FIELD_EDIT[J1].Free ;
    end ;
    FIELD_AFF := 0 ;
    VOIR_CONTROLES( false ) ;
end;

//======================================================================
procedure TF1.BTN3_GOClick(Sender: TObject);
begin
   //  simplement pour "sortie" de la zone de saisie N Record
end;

//========================================================
procedure TF1.BTN4_NEWClick(Sender: TObject);
begin
  NOUVEAU_RECORD ;
  if XBASE1.RecordCount >= 1 then
        VOIR_CONTROLES( true ) ;
end;

//========================================================
procedure TF1.BTN5_DELClick(Sender: TObject);
var V1 : boolean ;
begin
    V1 :=  XBASE1.Deleted ;
    if V1 then begin
          XBASE1.Deleted := false ;  // RActivation
          LDEL.Caption   := 'Actif'  ;
    end else begin
          XBASE1.Deleted := true  ;  // Suppression
          LDEL.Caption   := 'Deleted' ;
    end ;
end;

//========================================================
procedure TF1.BTN6_CREClick(Sender: TObject);
begin
   GET_NOM_FICHIER(1) ;
end;

//========================================================
procedure TF1.BTN7_CPYClick(Sender: TObject);
begin
   GET_NOM_FICHIER(2) ;
end;

//========================================================
procedure TF1.BTN8_DBFClick(Sender: TObject);
begin
   GET_NOM_FICHIER(3) ;
end;

//========================================================
procedure TF1.BTN9_EXITClick(Sender: TObject);
begin
   close ;
end;

//========================================================
procedure TF1.UpDown1Click(Sender: TObject; Button: TUDBtnType);
var X1 : cardinal ;
    V1 : boolean  ;
begin
   V1 := false ;
   X1 := XBase1.Recno ;
   // DEUXIEME VARIANTE : pour marcher il faut UpDown1.Min < -999 et .Max > +999
   case Button of
        btPrev :  begin
                  if X1 > 1 then  begin
                            UPDATE_RECORD ;
                            V1 := true ;
                            dec(X1) ;
                            XBase1.GotoPrev ; // idem  XBase1.GotoRecord(X1)
                            end
                  else ShowMessage('PREMIER RECORD' ) ;
                  end ;
        btNext :  begin
                  if X1 < XBase1.RecordCount then begin
                            UPDATE_RECORD ;
                            V1 := true ;
                            inc(X1) ;
                            XBase1.GotoNext ; // idem  XBase1.GotoRecord(X1)
                            end
                  else ShowMessage('DERNIER RECORD' ) ;
                  end ;
        else
                  ShowMessage('QUEL BOUTON ?????' ) ;
   end ;
   if V1 then begin
         AFFICHER_RECORD ;
         EDIT1.Text := IntToStr(X1) ;
   end ;
end;

//======================================================================
procedure TF1.XPOSITIONExit(Sender: TObject);
var
   S1 : STRINGX11 ;
   J1 : integer ;
begin
 if XPOSITION.Modified  then begin
   S1 := trim(XPOSITION.Text) ;
   if length(S1) = 0 then S1 := '1' ;
   J1 := StrToIntDef(S1 , 1 ) ;
   if J1 <= 0 then J1 := 1 ;
   if J1 <> XBASE1.Recno then begin
         XBASE1.GotoRecord( J1 ) ;
         AFFICHER_RECORD ;
   end ;
 end ;
end;

//**********************************************************************
end.
